﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.01
@EndOfDesignText@
'xChart Custom View class
'
'Version 1.5 2018.05.14
'Amended some bugs.
'changed the color properties from native colors to xui colors.
'added the YZeroAxis property.
'
'Version 1.4 2018.05.10
'Added gradient colors.

'Version 1.3 2018.05.02
'Amended the TextColor not used.
'Changed it to TitleTextColor

'Version 1.2 2018.04.29
'Amended the ScaleTextColor property not working.
'The old versions used the GridColor instead of the ScaleTextColor.
'
'Version 1.1 2018.04.26
'Added display of data values with a click
'Added different line widths on a same chart
'Added point shapes for line points
'
'Version 1.0 2018.04.26
'
'Written by Klaus CHRISTL (klaus)

#DesignerProperty: Key: Title, DisplayName: Title, FieldType: String, DefaultValue: Bar chart
#DesignerProperty: Key: XAxisName, DisplayName: X axis name, FieldType: String, DefaultValue: X axis
#DesignerProperty: Key: YAxisName, DisplayName: Yaxis name, FieldType: String, DefaultValue: Y axis
#DesignerProperty: Key: YMaxValue, DisplayName: Y max value, FieldType: Int, DefaultValue: 100
#DesignerProperty: Key: YMinValue, DisplayName: Y min vlaue, FieldType: Int, DefaultValue: 0
#DesignerProperty: Key: YZeroAxis, DisplayName: Y zero axis, FieldType: Boolean, DefaultValue: True, Description: Stes the min value to 0 if all values are > 0, and max valule to 0 if all values are <0
#DesignerProperty: Key: NbYIntervals, DisplayName: Number of Y intervals, FieldType: Int, DefaultValue: 10
#DesignerProperty: Key: ChartType, DisplayName: Chart type, FieldType: String, DefaultValue: BAR, List: LINE|BAR|STACKED_BAR|PIE
#DesignerProperty: Key: ChartColor, DisplayName: Chart background color, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: GridFrameColor, DisplayName: Grid frame color, FieldType: Color, DefaultValue: 0xFF000000, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: GridColor, DisplayName: Grid color, FieldType: Color, DefaultValue: 0xFFA9A9A9, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: TitleTextColor, DisplayName: Title text color, FieldType: Color, DefaultValue: 0xFF000000, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: GradientColors, DisplayName: Gradient colors, FieldType: Boolean, DefaultValue: True, Description:  Gradient colors for pies and bars
#DesignerProperty: Key: GradientColorsAlpha, DisplayName: Gradient colors alpha, FieldType: Int, DefaultValue: 96, MinRange: 0, MaxRange: 255, Description:  Gradient colors alpha value for pies and bars
#DesignerProperty: Key: ScaleTextColor, DisplayName: Scale text color, FieldType: Color, DefaultValue: 0xFF000000, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: TitleTextSize, DisplayName: Title text size, FieldType: Int, DefaultValue: 18
#DesignerProperty: Key: AxisTextSize, DisplayName: Axis name text size, FieldType: Int, DefaultValue: 14
#DesignerProperty: Key: ScaleTextSize, DisplayName: Scale text size, FieldType: Int, DefaultValue: 12
#DesignerProperty: Key: LegendTextSize, DisplayName: Legend text size, FieldType: Int, DefaultValue: 14
#DesignerProperty: Key: AutomaticTextSizes, DisplayName: Automatic text sizes, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: IncludeLegend, DisplayName: Include Legend, FieldType: String, DefaultValue: NONE, List: NONE|TOP_RIGHT|BOTTOM
#DesignerProperty: Key: IncludeValues, DisplayName: Include values in single bar charts or pie charts with TOP_RIGHT legend, FieldType: Boolean, DefaultValue: False
#DesignerProperty: Key: AutomaticScale, DisplayName: Automatic scale, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: XScaleTextOrientation, DisplayName: X scale text orientation, FieldType: String, DefaultValue: HORIZONTAL, List: HORIZONTAL|VERTICAL|45 DEGREES
#DesignerProperty: Key: PieGapDegrees, DisplayName: Gap in degrees in pie chart only, FieldType: Int, DefaultValue: 0
#DesignerProperty: Key: PieAddPerentage, DisplayName: Add percentage values in pie slices, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: ValuesShow, DisplayName: Show values when clicking on a chart, FieldType: Boolean, DefaultValue: True
#DesignerProperty: Key: ValuesTextSize, DisplayName: Values text size, FieldType: Int, DefaultValue: 14
#DesignerProperty: Key: ValuesTextColor, DisplayName: Values text color, FieldType: Color, DefaultValue: 0xFF000000

Sub Class_Globals
	Type GraphData (Title As String, XAxisName As String, YAxisName As String, Left As Int, Right As Int, Top As Int, Bottom As Int, Width As Int, Height As Int, Rect As B4XRect, YInterval As Int, XInterval As Int, XOffset As Int, BarWidth As Int, ChartType As String, BarSubWidth As Int, IncludeValues As Boolean, ChartColor As Int, GridFrameColor As Int, GridColor As Int, XScaleTextOrientation As String, PieGapDegrees As Int, PieAddPerentage As Boolean, GradientColors As Boolean, GradientColorsAlpha As Int)
	Type PointData (X As String, YArray() As Double, ShowTick As Boolean)
	Type ItemData (Name As String, Color As Int, Value As Float, StrokeWidth As Int, PointType As String, Filled As Boolean, PointColor As Int)
	Type ScaleData (X As Double, Y As Double, MinVal As Double, MaxVal As Double, MinManu As Double, MaxManu As Double,	YIntervalManu As Double, MinAuto As Double, MaxAuto As Double, YIntervalAuto As Double, YInterval As Double, NbYIntervals As Int, NbXIntervals As Int, XInterval As Int, Automatic As Boolean, Exp As Double, YZeroAxis As Boolean)
	Type TextData (TitleFont As B4XFont, AxisFont As B4XFont, ScaleFont As B4XFont, AutomaticTextSizes As Boolean, TitleTextSize As Float, TitleTextColor As Int, AxisTextSize As Float, ScaleTextSize As Float, ScaleTextColor As Int, TitleTextHeight As Int, AxisTextHeight As Int, ScaleTextHeight As Int)
	Type LegendData (IncludeLegend As String, TextFont As B4XFont, TextSize As Float, TextHeight As Int, Height As Int, LineNumber As Int, LineNumbers As List, LineChange As List)
	Type ValuesData (Show As Boolean, TextFont As B4XFont, TextSize As Float, TextColor As Int, TextHeight As Int, Left As Int, Top As Int, Width As Int, Height As Int, MidPont As Int, rectRight As B4XRect, rectCursor As B4XRect, MaxDigits As Int)
#If B4J
	Private fx As JFX
#End If	
	Private xui As XUI
	
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	
	Private xBase As B4XView
	Private xcvsGraph As B4XCanvas
	Private xpnlValues As B4XView
	Private xcvsValues As B4XCanvas
	Private xpnlCursor As B4XView
	Private xcvsCursor As B4XCanvas

	Private Scale As ScaleData
	Private Items As List
	Private Points As List
	Private Graph As GraphData
	Private Texts As TextData
	Private Legend As LegendData
	Private Values As ValuesData
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	xBase = Base
	
	xcvsGraph.Initialize(xBase)
	
	Scale.Initialize
	Items.Initialize
	Points.Initialize
	Graph.Initialize
	Texts.Initialize
	Legend.Initialize
	Values.Initialize
	
	Legend.LineNumbers.Initialize
	Legend.LineChange.Initialize
	
	Graph.Title = Props.Get("Title")
	Graph.XAxisName = Props.Get("XAxisName")
	Graph.YAxisName = Props.Get("YAxisName")
	Scale.MaxManu = Props.Get("YMaxValue")
	Scale.MinManu = Props.Get("YMinValue")
	Scale.NbYIntervals = Props.Get("NbYIntervals")
	Scale.YZeroAxis = Props.Get("YZeroAxis")
	Graph.ChartType = Props.Get("ChartType")
	Graph.ChartColor = xui.PaintOrColorToColor(Props.Get("ChartColor"))
	Graph.GridFrameColor = xui.PaintOrColorToColor(Props.Get("GridFrameColor"))
	Graph.GridColor = xui.PaintOrColorToColor(Props.Get("GridColor"))
	Graph.GradientColors = Props.Get("GradientColors")
	Graph.GradientColorsAlpha = Props.Get("GradientColorsAlpha")
	Texts.TitleTextColor = xui.PaintOrColorToColor(Props.Get("TitleTextColor"))
	Texts.ScaleTextColor = xui.PaintOrColorToColor(Props.Get("ScaleTextColor"))
	Texts.TitleTextSize = Props.Get("TitleTextSize")
	Texts.AxisTextSize = Props.Get("AxisTextSize")
	Texts.ScaleTextSize = Props.Get("ScaleTextSize")
	Legend.TextSize = Props.Get("LegendTextSize")
	Texts.AutomaticTextSizes = Props.Get("AutomaticTextSizes")
	Scale.Automatic = Props.Get("AutomaticScale")
	Graph.XScaleTextOrientation = Props.Get("XScaleTextOrientation")
	Legend.IncludeLegend = Props.Get("IncludeLegend")
	Graph.IncludeValues = Props.Get("IncludeValues")
	Graph.PieAddPerentage = Props.Get("PieAddPerentage")
	Graph.PieGapDegrees = Props.Get("PieGapDegrees")
	Values.Show = Props.Get("ValuesShow")
	Values.TextSize = Props.Get("ValuesTextSize")
	Values.TextColor = xui.PaintOrColorToColor(Props.Get("ValuesTextColor"))
	
	xpnlCursor = xui.CreatePanel("xCursor")
	xBase.AddView(xpnlCursor, 0, 0, xBase.Width, xBase.Height)
	xcvsCursor.Initialize(xpnlCursor)
	
	xpnlValues = xui.CreatePanel("xpnlValues")
	xBase.AddView(xpnlValues, 0, 0, 100dip, 100dip)
	xpnlValues.Visible = False
	xcvsValues.Initialize(xpnlValues)
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	xcvsGraph.Resize(Width, Height)
	xpnlCursor.Width = Width
	xpnlCursor.Height = Height
	xcvsCursor.Resize(Width, Height)
	If Points.Size > 0 Or Graph.ChartType = "PIE" Then
		DrawChart
	End If
End Sub

#If B4J
Private Sub xCursor_MousePressed (EventData As MouseEvent)
	If Values.Show = True And EventData.X > Graph.Left And EventData.X < Graph.Right And EventData.Y > Graph.Top And EventData.Y < Graph.Bottom Then
		DrawItemValues(EventData.X, EventData.Y)
		xpnlValues.Visible = True
	End If
End Sub

Private Sub xCursor_MouseDragged (EventData As MouseEvent)
	If Values.Show = True And EventData.X > Graph.Left And EventData.X < Graph.Right And EventData.Y > Graph.Top And EventData.Y < Graph.Bottom Then
		DrawItemValues(EventData.X, EventData.Y)
	End If
End Sub

Private Sub xCursor_MouseReleased (EventData As MouseEvent)
	xpnlValues.Visible = False
	xcvsCursor.ClearRect(Values.rectCursor)
	xcvsCursor.Invalidate
End Sub
#Else
Private Sub xCursor_Touch (Action As Int, X As Float, Y As Float)
	Select Action
		Case 0	'DOWN
			If X > Graph.Left And X < Graph.Right And Y > Graph.Top And Y < Graph.Bottom Then
				DrawItemValues(X, Y)
				xpnlValues.Visible = True
			End If
		Case 1	'UP
			xpnlValues.Visible = False
			xcvsCursor.ClearRect(Values.rectCursor)
			xcvsCursor.Invalidate
		Case 2	'MOVE
			If X > Graph.Left And X < Graph.Right And Y > Graph.Top And Y < Graph.Bottom Then
				DrawItemValues(X, Y)
			End If
	End Select
End Sub
#End If

Private Sub InitValues
	Private r As B4XRect

	Values.Left = 0.3 * Values.TextHeight
	Values.Top = 0.3 * Values.TextHeight
	Values.MaxDigits = 6
	Values.Height = Values.TextHeight * 1.2 * (Items.Size + 1)
	
	Private ItemWidth As Int
	For Each Item As ItemData In Items
		Private txt As String = Item.Name & " = "
		ItemWidth = Max(ItemWidth, MeasureTextWidth(txt, Values.TextFont))
	Next
	If Graph.ChartType = "STACKED_BAR" Then
		ItemWidth = Max(ItemWidth, MeasureTextWidth("Total = ", Values.TextFont))
		Values.Height = Values.TextHeight * 1.2 * (Items.Size + 2)
	End If
	ItemWidth = ItemWidth + 1.2 * Values.TextHeight
	Values.MidPont = ItemWidth - 0.6 * Values.TextHeight
	Private ValueWidth = MeasureTextWidth("-1.23456", Values.TextFont) As Int
	For Each pnt As PointData In Points
		Private txt As String = pnt.X
		ValueWidth = Max(ValueWidth, MeasureTextWidth(txt, Values.TextFont))
	Next
	Values.Width = ItemWidth + ValueWidth
	Values.rectRight.Initialize(Values.MidPont, 0, Values.Width, Values.Height)
	Values.rectCursor.Initialize(0, 0, 5dip, xpnlCursor.Height)
	
	xpnlValues.Left = Values.Left
	xpnlValues.Top = Values.Top
	xpnlValues.Width = Values.Width
	xpnlValues.Height = Values.Height
	xcvsValues.Resize(Values.Width, Values.Height)
	
	r.Initialize(0, 0, Values.Width, Values.Height)
	xcvsValues.ClearRect(r)
	xcvsValues.DrawRect(r, 0xAAFFFFFF, True, 0)
	
	Private h, i, x, y As Int
	h = Values.TextHeight * 1.2
	x = Values.MidPont
	y = 0.8 * Values.TextHeight
	xcvsValues.DrawText("x = ", x, y + 0.2 * h, Values.TextFont, Values.TextColor, "RIGHT")
	i = 1
	For Each Item As ItemData In Items
		Private top As Int = y + h * i
		Private txt As String = Item.Name & " = "
		xcvsValues.DrawText(txt, x, top + 0.2 * h, Values.TextFont, Item.Color, "RIGHT")
		i = i + 1
	Next
	
	If Graph.ChartType = "STACKED_BAR" Then
		Private top As Int = y + h * i
		Private txt As String = "Total = "
		xcvsValues.DrawText(txt, x, top + 0.2 * h, Values.TextFont, Values.TextColor, "RIGHT")
	End If
	
	xcvsValues.Invalidate
End Sub

Private Sub DrawItemValues(x As Int, y As Int)
	If Graph.ChartType <> "PIE" Then
		Private Index As Int
		xcvsValues.ClearRect(Values.rectRight)
		xcvsCursor.ClearRect(Values.rectCursor)
		xcvsValues.DrawRect(Values.rectRight, 0xAAFFFFFF, True, 0)
		Select Graph.ChartType
			Case "BAR", "STACKED_BAR"
				Index =(x - Graph.Left) / Graph.XInterval
			Case "LINE"
				Index = (x - Graph.Left) / Scale.X + 0.5
		End Select
		Index = Min(Index, Points.Size - 1)
		Private Point As PointData
		Point = Points.Get(Index)
		Private h, i, x, y As Int
		h = Values.TextHeight * 1.2
		x = Values.MidPont
		y = 0.8 * Values.TextHeight
		xcvsValues.DrawText(Point.X, x, y + 0.2 * h, Values.TextFont, Values.TextColor, "LEFT")
		Private Total = 0 As Double
		For i = 0 To Point.YArray.Length - 1
			Private top As Int = y + h * (i + 1)
			xcvsValues.DrawText(NumberFormat3(Point.YArray(i), Values.MaxDigits), x, top + 0.2 * h, Values.TextFont, Values.TextColor, "LEFT")
			Total = Total + Point.YArray(i)
		Next
		Private top As Int = y + h * (i + 1)
		xcvsValues.DrawText(NumberFormat3(Total, Values.MaxDigits), x, top + 0.2 * h, Values.TextFont, xui.Color_Black, "LEFT")
		
		Private xCursor As Int
		Select Graph.ChartType
			Case "BAR", "STACKED_BAR"
				xCursor = (Index + 0.5) * Graph.XInterval + Graph.Left + Graph.XOffset
			Case "LINE"
				xCursor = Index * Scale.X + Graph.Left 
		End Select		
		xcvsCursor.DrawLine(xCursor, Graph.Top, xCursor, Graph.Bottom, xui.Color_Red, 2dip)
		Values.rectCursor.Initialize(xCursor - 2dip, 0, xCursor + 2dip, xpnlCursor.Height)
		xcvsValues.Invalidate
		xcvsCursor.Invalidate
	End If
End Sub

'adds a bar
Public Sub AddBar(Name As String, BarColor As Int)
	If Items.IsInitialized = False Then
		Items.Initialize
	End If
	
	Private ID As ItemData
	ID.Initialize
	ID.Name = Name
	ID.Color = BarColor
	Items.Add(ID)
End Sub

'adds multibar points data
Public Sub AddBarMultiplePoint (X As String, YArray() As Double)
	If Points.IsInitialized = False Then
		Points.Initialize
	End If
	Dim PD As PointData
	PD.Initialize
	PD.X = X
	PD.YArray = YArray
	PD.ShowTick = True
	Points.Add(PD)
End Sub

'adds single bar point data
Public Sub AddBarPointData (X As String, Y As Double)
	If Points.IsInitialized = False Then
		Points.Initialize
	End If
	Dim PD As PointData
	PD.Initialize
	PD.X = X
	Private YArray(1) As Double
	YArray(0) = Y
	PD.YArray = YArray
	PD.ShowTick = True
	Points.Add(PD)
End Sub

'adds a line
Public Sub AddLine(Name As String, LineColor As Int)
	If Items.IsInitialized = False Then
		Items.Initialize
	End If
	If LineColor = 0 Then LineColor = xui.Color_RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	
	Dim ID As ItemData
	ID.Initialize
	ID.Name = Name
	ID.Color = LineColor
	ID.StrokeWidth = 2dip
	ID.PointType = "NONE"
	ID.Filled = False
	Items.Add(ID)
End Sub

'adds a line
'StrokeWidth = line thickness
'PointType, possible values: "NONE", "CIRCLE", "SQUARE", "TRIANGLE", "RHOMBUS", "CROSS+", "CROSSX"
Public Sub AddLine2(Name As String, LineColor As Int, StrokeWidth As Int, PointType As String, Filled As Boolean, PointColor As Int)
	If Items.IsInitialized = False Then
		Items.Initialize
	End If
	If LineColor = 0 Then LineColor = xui.Color_RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	
	Dim ID As ItemData
	ID.Initialize
	ID.Name = Name
	ID.Color = LineColor
	ID.StrokeWidth = StrokeWidth
	ID.PointType = PointType
	ID.Filled = Filled
	ID.PointColor = PointColor
	Items.Add(ID)
End Sub

'adds multiline points data
Public Sub AddLineMultiplePoints(X As String, YArray() As Double, ShowTick As Boolean)
	If Points.IsInitialized = False Then Points.Initialize
	Private PD As PointData
	PD.Initialize
	PD.X = X
	PD.YArray = YArray
	PD.ShowTick = ShowTick
	Points.Add(PD)
End Sub

'adds single line point data
Public Sub AddLinePointData (X As String, Y As Double, ShowTick As Boolean)
	If Points.IsInitialized = False Then Points.Initialize
	Dim PD As PointData
	PD.Initialize
	PD.X = X
	Private YArray(1) As Double
	YArray(0) = Y
	PD.YArray = YArray
	PD.ShowTick = ShowTick
	Points.Add(PD)
End Sub

'Adds a pie slice item
'Color: 0 = random color
Public Sub AddPie(Name As String, Value As Float, Color As Int)
	If Items.IsInitialized = False Then
		Items.Initialize
	End If
	If Color = 0 Then Color = xui.Color_RGB(Rnd(0, 255), Rnd(0, 255), Rnd(0, 255))
	Dim ID As ItemData
	ID.Initialize
	ID.Name = Name
	ID.Value = Value
	ID.Color = Color
	Items.Add(ID)
End Sub

'initializes different parameters for a chart
Private Sub InitChart
	If Texts.AutomaticTextSizes = True Then
		Private GraphSize As Int
		GraphSize = Min(xcvsGraph.TargetRect.Width, xcvsGraph.TargetRect.Height)
#If B4A
		GraphSize = GraphSize / GetDeviceLayoutValues.Scale
#End If
		Texts.TitleTextSize = (1 + (GraphSize - 250)/1000) * 18
		Texts.AxisTextSize = (1 + (GraphSize - 250)/1000) * 14
		Legend.TextSize = (1 + (GraphSize - 250)/1000) * 14
		Texts.ScaleTextSize = (1 + (GraphSize - 250)/1000) * 12
		Values.TextSize = (1 + (GraphSize - 250)/1000) * 14
	End If

	Texts.TitleFont = xui.CreateDefaultFont(Texts.TitleTextSize)
	Texts.AxisFont = xui.CreateDefaultFont(Texts.AxisTextSize)
	Texts.ScaleFont = xui.CreateDefaultFont(Texts.ScaleTextSize)
	Legend.TextFont = xui.CreateDefaultFont(Legend.TextSize)
	Values.TextFont = xui.CreateDefaultFont(Values.TextSize)
	
	Texts.TitleTextHeight = MeasureTextHeight("Mg", Texts.TitleFont)
	Texts.AxisTextHeight = MeasureTextHeight("Mg", Texts.AxisFont)
	Texts.ScaleTextHeight = MeasureTextHeight("Mg", Texts.ScaleFont)
	Legend.TextHeight = MeasureTextHeight("Mg", Legend.TextFont)
	Values.TextHeight = MeasureTextHeight("Mg", Values.TextFont)
	If Graph.ChartType = "PIE" Then
		Return
	End If

	If Scale.Automatic = True Then
		CalcScaleAuto
	Else
		CalcScaleManu
	End If
	
	Graph.Left = GetYScaleWidth + 0.7 * Texts.ScaleTextHeight

	If Graph.YAxisName <> "" Then
		Graph.Left = Graph.Left + Texts.AxisTextHeight * 1.2
	End If
	
	Graph.Right = xcvsGraph.TargetRect.Width - Texts.ScaleTextHeight
	Graph.Width = Graph.Right - Graph.Left
	
	If Graph.ChartType = "BAR" Or Graph.ChartType = "STACKED_BAR" Then
		Private Space = 0.02 * xcvsGraph.TargetRect.Width As Int
		Graph.XInterval = (Graph.Width - Space) / Points.Size
		Graph.XOffset = (Graph.Width - Graph.XInterval * Points.Size) / 2
		Graph.BarWidth = Graph.XInterval - Space
		Private PD As PointData = Points.Get(0)
		Graph.BarSubWidth = Graph.BarWidth / PD.YArray.Length
	End If
	
	Graph.Top = 0.8 * Texts.TitleTextHeight
	
	If Graph.Title <> "" Then
		Graph.Top = Graph.Top + Texts.TitleTextHeight
	End If
	
	Select Graph.XScaleTextOrientation
		Case "HORIZONTAL"
			Graph.Height = xcvsGraph.TargetRect.Height - Graph.Top - 1.4 * Texts.ScaleTextHeight
		Case "VERTICAL"
			Graph.Height = xcvsGraph.TargetRect.Height - Graph.Top - 0.6 * Texts.ScaleTextHeight - GetXScaleWidth
		Case "45 DEGREES"
			Graph.Height = xcvsGraph.TargetRect.Height - Graph.Top - 0.6 * Texts.ScaleTextHeight - GetXScaleWidth * 0.8
	End Select
	
	If Graph.XAxisName <> "" Then
		Graph.Height = Graph.Height - 1.3 * Texts.AxisTextHeight
	End If
	
	If Legend.IncludeLegend = "BOTTOM" And Items.Size > 0 Then
		GetLegendLineNumbers(xcvsGraph.TargetRect.Width - 0.8 * Legend.TextHeight)
		Legend.Height = (Legend.LineNumber + 0.2) * Legend.TextHeight
		Graph.Height = Graph.Height - Legend.Height - 0.5 * Legend.TextHeight
	End If
	
	Graph.YInterval = Graph.Height / Scale.NbYIntervals
	Graph.Height =  Graph.YInterval * Scale.NbYIntervals
	Graph.Bottom = Graph.Top + Graph.Height
	Graph.Rect.Initialize(Graph.Left, Graph.Top, Graph.Right, Graph.Bottom)
	
	InitValues
End Sub

'Calculates manual scales
Private Sub CalcScaleManu
	Scale.MaxVal = Scale.MaxManu
	Scale.MinVal = Scale.MinManu
	Scale.YIntervalManu = (Scale.MaxVal - Scale.MinVal) / Scale.NbYIntervals
	Scale.YInterval = Scale.YIntervalManu
	Scale.Exp = Floor(Logarithm((Scale.MaxVal - Scale.MinVal) / Scale.NbYIntervals, 10))
	Scale.Y = Graph.Height / (Scale.MaxVal - Scale.MinVal)
End Sub

'Calculates automatic scales with 1, 2, 2.5, 5 standardized scales
Private Sub CalcScaleAuto
	Private ScaleLog, ScaleMant, ScaleDelta, ValDiff As Double
	Private Log1, Log2, Log25, Log5, Log10 As Double
	Private nbMin, NbUsedIntervals, NbUsedIntervalsTop, NbUsedIntervalsBottom, NbIntervalsToMove As Int
	Private ValMinMax(2) As Double
	
	If Graph.ChartType = "LINE" Then
		ValMinMax = GetLinePointsMinMaxValues
		If Scale.YZeroAxis = True And ValMinMax(0) >= 0 And ValMinMax(1) > 0 Then
			ValMinMax(0) = 0
		End If
		If Scale.YZeroAxis = True And ValMinMax(0) < 0 And ValMinMax(1) <= 0 Then
			ValMinMax(1) = 0
		End If
	Else
		ValMinMax = GetBarPointsMinMaxValues
	End If
	
	'check if min = max then unit scale
	If ValMinMax(0) = ValMinMax(1) Then
		Scale.YIntervalAuto = 1
		Scale.MinAuto = Floor(ValMinMax(0)) - Scale.YIntervalAuto * Scale.NbYIntervals / 2
		Scale.MaxAuto = Scale.MinAuto + Scale.YIntervalAuto * Scale.NbYIntervals
		Scale.MinVal = Scale.MinAuto
		Scale.MaxVal = Scale.MaxAuto
		Scale.YInterval = Scale.YIntervalAuto
		Scale.Y = Graph.Height / (Scale.MaxVal - Scale.MinVal)
	End If
	
	' logarithm variables
	Log1 = 0.00000000000001
	Log2 = Logarithm(2, 10) + 0.00000000000001
	Log25 = Logarithm(2.5, 10) + 0.00000000000001
	Log5 = Logarithm(5, 10) + 0.00000000000001
	Log10 = Logarithm(10, 10) + 0.00000000000001
	
	ValDiff = ValMinMax(1) - ValMinMax(0)
	ScaleDelta = ValDiff / Scale.NbYIntervals
	
	ScaleLog = Logarithm(ScaleDelta, 10)
	Scale.Exp = Floor(ScaleLog)
	If ValDiff >= 1 Then
		ScaleMant = ScaleLog - Scale.Exp
	Else
		ScaleMant = Abs(Scale.Exp) + ScaleLog
	End If
	
	' calculate the scale interval
	If ScaleMant <= Log1 Then
		ScaleMant = 0
	Else If ScaleMant > Log1 And ScaleMant <= Log2 Then
		ScaleMant = Logarithm(2, 10)
	Else If ScaleMant > Log2 And ScaleMant <= Log25 Then
		ScaleMant = Logarithm(2.5, 10)
	Else If ScaleMant > Log25 And ScaleMant <= Log5 Then
		ScaleMant = Logarithm(5, 10)
	Else If ScaleMant > Log5 And ScaleMant <= Log10 Then
		ScaleMant = 1
	End If
	Scale.YIntervalAuto = Power(10, Scale.Exp + ScaleMant)
	
	' check if the scale interval is OK
	If ValMinMax(0) < 0 And ValMinMax(1) > 0 Then
		NbUsedIntervalsTop = Ceil(ValMinMax(1) / Scale.YIntervalAuto - 0.00000000000001)
		NbUsedIntervalsBottom = Ceil(Abs(ValMinMax(0)) / Scale.YIntervalAuto - 0.00000000000001)
		' check if there are more necessary intervals than available
		If NbUsedIntervalsTop + NbUsedIntervalsBottom > Scale.NbYIntervals Then
			' if yes increas the scale interval
			If ScaleMant <= Log1 Then
				ScaleMant = Logarithm(2, 10)
			Else If ScaleMant > Log1 And ScaleMant <= Log2 Then
				ScaleMant = Logarithm(2.5, 10)
			Else If ScaleMant > Log2 And ScaleMant <= Log25 Then
				ScaleMant = Logarithm(5, 10)
			Else If ScaleMant > Log25 And ScaleMant <= Log5 Then
				ScaleMant = 1
			Else If ScaleMant > Log5 And ScaleMant <= Log10 Then
				ScaleMant = Logarithm(20, 10)
			End If
			Scale.YIntervalAuto = Power(10, Scale.Exp + ScaleMant)
		End If
	End If
	
	' calculate the scale min value
	nbMin = Floor(ValMinMax(0) / Scale.YIntervalAuto)
	If Abs(ValMinMax(0)) <= 0.0000000000001 Then
		Scale.MinAuto = 0
	Else If ValMinMax(0) >= 0 Then
		Scale.MinAuto = nbMin * Scale.YIntervalAuto
	Else If ValMinMax(0) < 0 And ValMinMax(1) > 0 Then
		Scale.MinAuto = Floor(ValMinMax(0) / Scale.YIntervalAuto + 0.00000000000001) * Scale.YIntervalAuto
	Else
		Scale.MinAuto = Floor(ValMinMax(0) / Scale.YIntervalAuto + 0.00000000000001) * Scale.YIntervalAuto
	End If
	
	' distribution of empty intervals
	If Abs(Scale.MinAuto) > 0.0000000000001 Then
		If ValMinMax(0) < 0 And ValMinMax(1) > 0 Then
			NbUsedIntervalsTop = Ceil(ValMinMax(1) / Scale.YIntervalAuto - 0.00000000000001)
			NbUsedIntervalsBottom = Ceil(Abs(ValMinMax(0)) / Scale.YIntervalAuto - 0.00000000000001)
			NbUsedIntervals = NbUsedIntervalsTop + NbUsedIntervalsBottom
			If NbUsedIntervalsTop - NbUsedIntervalsBottom = 1 Then
				NbIntervalsToMove = Scale.NbYIntervals / 2 - NbUsedIntervalsBottom
			Else
				NbIntervalsToMove = (Scale.NbYIntervals - NbUsedIntervals) / 2
			End If
		Else
			NbUsedIntervals = Ceil(ValDiff / Scale.YIntervalAuto - 0.00000000000001)
			NbIntervalsToMove = (Scale.NbYIntervals - NbUsedIntervals) / 2
		End If
		Scale.MinAuto = Scale.MinAuto - Scale.YIntervalAuto * NbIntervalsToMove
	End If
	
	If Graph.ChartType = "BAR" Then
		'if all values are > 0 and the min scale is < 0 then min scale is set to 0
		If 	ValMinMax(0) = 0 And ValMinMax(1) > 0 And Scale.MinAuto < 0 Then
			Scale.MinAuto = 0
		End If
		
		'if all values are < 0 and the max scale is > 0 then max scale is set to 0
		If 	ValMinMax(0) < 0 And ValMinMax(1) = 0 And Scale.MinAuto + Scale.YIntervalAuto * Scale.NbYIntervals > 0 Then
			Scale.MinAuto = - Scale.YIntervalAuto * Scale.NbYIntervals
		End If
	End If
	
	' calculate the scale max value
	Scale.MaxAuto = Scale.MinAuto + Scale.YIntervalAuto * Scale.NbYIntervals
	
	Scale.MinVal = Scale.MinAuto
	Scale.MaxVal = Scale.MaxAuto
	Scale.YInterval = Scale.YIntervalAuto
	Scale.Y = Graph.Height / (Scale.MaxVal - Scale.MinVal)
End Sub

'gets min and max values of the given points for bars
Private Sub GetBarPointsMinMaxValues As Double()
	Private j, j As Int
	Private MinMax(2) As Double
	
	If Graph.ChartType = "BAR" Then
		' BAR chart
		MinMax(1) = -1E10
		MinMax(0) = 1E10
	
		For i = 0 To Points.Size - 1
			Private YVals() As Double
			Private PD As PointData
			PD = Points.Get(i)
			YVals = PD.YArray
			For j = 0 To PD.YArray.Length - 1
				MinMax(1) = Max(MinMax(1), YVals(j))
				MinMax(0) = Min(MinMax(0), YVals(j))
			Next
		Next
		If MinMax(0) > 0 And MinMax(1) > 0 Then
			MinMax(0) = 0
		End If
		If MinMax(0) < 0 And MinMax(1) < 0 Then
			MinMax(1) = 0
		End If
	Else
		' STACKED BAR chart
		MinMax(1) = 0
		MinMax(0) = 0
	
		For i = 0 To Points.Size - 1
			Private YVals(), Total As Double
			Private PD As PointData
			PD = Points.Get(i)
			YVals = PD.YArray
			For j = 0 To PD.YArray.Length - 1
				Total = Total + YVals(j)
			Next
			MinMax(1) = Max(MinMax(1), Total)
		Next
	End If
	
	Return MinMax
End Sub

'gets min and max values of the given points for lines
Private Sub GetLinePointsMinMaxValues As Double()
	Private j, j As Int
	Private MinMax(2) As Double

	MinMax(1) = -1E10
	MinMax(0) = 1E10
	
	For i = 0 To Points.Size - 1
		Private YVals() As Double
		Private PD As PointData
		PD = Points.Get(i)
		YVals = PD.YArray
		For j = 0 To PD.YArray.Length - 1
			MinMax(1) = Max(MinMax(1), YVals(j))
			MinMax(0) = Min(MinMax(0), YVals(j))
		Next
	Next
	Return MinMax
End Sub

'gets the max width of the x scale values in pixels
Private Sub GetXScaleWidth As Int
	Private Width As Int
	
	For i = 0 To Points.Size - 1
		Private PD As PointData
		PD = Points.Get(i)
		If Graph.ChartType = "LINE" And PD.ShowTick = True Then
			Width = Max(Width, MeasureTextWidth(PD.X, Texts.ScaleFont))
		Else
			Width = Max(Width, MeasureTextWidth(PD.X, Texts.ScaleFont))
		End If
	Next

	Return Width
End Sub

'gets the max width of the y scale values in pixels
Private Sub GetYScaleWidth As Int
	Private Width As Int
	
	If Scale.Automatic = True Then
		Width = MeasureTextWidth(NumberFormat2(Scale.MaxVal, 1, Abs(Scale.Exp), 0, False), Texts.ScaleFont)
		Width = Max(Width, MeasureTextWidth(NumberFormat2(Scale.MinVal, 1, Abs(Scale.Exp), 0, False), Texts.ScaleFont))
		Width = Max(Width, MeasureTextWidth(NumberFormat2(Scale.YInterval, 1, Abs(Scale.Exp), 0, False), Texts.ScaleFont))
	Else
		Width = MeasureTextWidth(NumberFormat2(Scale.MaxVal, 1, Abs(Scale.Exp), 0, False), Texts.ScaleFont)
		Width = Max(Width, MeasureTextWidth(NumberFormat2(Scale.MinVal, 1, Abs(Scale.Exp), 0, False), Texts.ScaleFont))
		Width = Max(Width, MeasureTextWidth(NumberFormat2(Scale.YInterval, 1, Abs(Scale.Exp), 0, False), Texts.ScaleFont))
		Width = Max(Width, MeasureTextWidth(NumberFormat2(Scale.MaxVal - Scale.YInterval, 1, Abs(Scale.Exp), 0, False), Texts.ScaleFont))
	End If

	Return Width
End Sub

'draws a chart
Public Sub DrawChart
	InitChart
	Select Graph.ChartType
		Case "LINE"
			GetXIntervals
			DrawGrid
			DrawLines
		Case "BAR", "STACKED_BAR"
			DrawGrid
			DrawBars
		Case "PIE"
			DrawPies
	End Select
End Sub

'draws the grid of a chart with the scales, titles and axis names, not for PIE charts
Private Sub DrawGrid
	Private i, x, x1, y As Int
	
	Scale.Y = Graph.Height / (Scale.MaxVal - Scale.MinVal)
	xcvsGraph.DrawRect(xcvsGraph.TargetRect, Graph.ChartColor, True, 1dip)
	
	For i = 0 To Scale.NbYIntervals
		y = Graph.Top + i * Graph.YInterval
		xcvsGraph.DrawLine(Graph.Left - 4dip, y, Graph.Left, y, Graph.GridFrameColor, 2dip)
		xcvsGraph.DrawLine(Graph.Left, y, Graph.Right, y, Graph.GridColor, 1dip)
		Private txt As String
		txt = NumberFormat2(Scale.MaxVal - i * Scale.YInterval, 1, Abs(Scale.Exp), 0, False)
#if B4A
		xcvsGraph.DrawText(txt, Graph.Left - 0.5 * Texts.ScaleTextHeight, y + 0.35 * Texts.ScaleTextHeight, Texts.ScaleFont, Texts.ScaleTextColor, "RIGHT")
#Else If B4J
		xcvsGraph.DrawText(txt, Graph.Left - 0.4 * Texts.ScaleTextHeight, y + 0.25 * Texts.ScaleTextHeight, Texts.ScaleFont, Texts.ScaleTextColor, "RIGHT")
#Else
		xcvsGraph.DrawText(txt, Graph.Left - 0.4 * Texts.ScaleTextHeight, y + 0.35 * Texts.ScaleTextHeight, Texts.ScaleFont, Texts.ScaleTextColor, "RIGHT")
#End If
	Next
	
	For i = 0 To Points.Size - 1
		Private PD As PointData
		PD = Points.Get(i)
		If Graph.ChartType = "LINE" Then
			x = Graph.Left + i * Scale.X
		Else
			x = Graph.Left + Graph.XOffset + (i + 0.5) * Graph.XInterval
		End If
#If B4i
		If PD.ShowTick = True Then
			xcvsGraph.DrawLine(x, Graph.Bottom, x, Graph.Bottom + 4dip, Graph.GridFrameColor, 2dip)
			xcvsGraph.DrawLine(x, Graph.Top, x, Graph.Bottom, Graph.GridColor, 1dip)
			Select Graph.XScaleTextOrientation
				Case "HORIZONTAL"
					xcvsGraph.DrawText(PD.X, x, Graph.Bottom + 1.35 * Texts.ScaleTextHeight, Texts.ScaleFont, Texts.ScaleTextColor, "CENTER")
				Case "VERTICAL"
					xcvsGraph.DrawTextRotated(PD.X, x + 0.33 * Texts.ScaleTextHeight, Graph.Bottom + 0.5 * Texts.ScaleTextHeight, Texts.ScaleFont, Texts.ScaleTextColor, "RIGHT", -90)
				Case "45 DEGREES"
					xcvsGraph.DrawTextRotated(PD.X, x + 0.4 * Texts.ScaleTextHeight, Graph.Bottom + 0.9 * Texts.ScaleTextHeight, Texts.ScaleFont, Texts.ScaleTextColor, "RIGHT", -45)
			End Select
		End If
#Else
		If PD.ShowTick = True Then
			xcvsGraph.DrawLine(x, Graph.Bottom, x, Graph.Bottom + 4dip, Graph.GridFrameColor, 2dip)
			xcvsGraph.DrawLine(x, Graph.Top, x, Graph.Bottom, Graph.GridColor, 1dip)
			Select Graph.XScaleTextOrientation
				Case "HORIZONTAL"
					xcvsGraph.DrawText(PD.X, x, Graph.Bottom + 1.1 * Texts.ScaleTextHeight, Texts.ScaleFont, Texts.ScaleTextColor, "CENTER")
				Case "VERTICAL"
					xcvsGraph.DrawTextRotated(PD.X, x + 0.25 * Texts.ScaleTextHeight, Graph.Bottom + 0.6 * Texts.ScaleTextHeight, Texts.ScaleFont, Texts.ScaleTextColor, "RIGHT", -90)
				Case "45 DEGREES"
					xcvsGraph.DrawTextRotated(PD.X, x + 0.3 * Texts.ScaleTextHeight, Graph.Bottom + 0.8 * Texts.ScaleTextHeight, Texts.ScaleFont, Texts.ScaleTextColor, "RIGHT", -45)
			End Select
		End If
#End If
	Next
	
	If Graph.Title <> "" Then
		xcvsGraph.DrawText(Graph.Title, Graph.Left + Graph.Width / 2, 1.15 * Texts.TitleTextHeight, Texts.TitleFont, Texts.TitleTextColor, "CENTER")
	End If
	
	y = xcvsGraph.TargetRect.Height - 0.4 * Texts.AxisTextHeight
	If Legend.IncludeLegend = "BOTTOM" Then
		y = y - Legend.Height - 0.5 * Legend.TextHeight
	End If
	
	If Graph.XAxisName <> "" Then
		xcvsGraph.DrawText(Graph.XAxisName, Graph.Left + Graph.Width / 2, y, Texts.AxisFont, Graph.GridFrameColor, "CENTER")
	End If
	
	x1 = Texts.AxisTextHeight
	If xui.IsB4i Then x1 = 1.2 * Texts.AxisTextHeight
	If Graph.YAxisName <> "" Then
		xcvsGraph.DrawTextRotated(Graph.YAxisName, x1, Graph.Top + Graph.Height / 2, Texts.AxisFont, Graph.GridFrameColor, "CENTER", -90)
	End If
	
	xcvsGraph.DrawRect(Graph.Rect, Graph.GridFrameColor, False, 2dip)
End Sub

'draws the lines in a LINE chart
Private Sub DrawLines
	Private i As Int
	Private x0, x1 As Int
	
	Private PD As PointData
	Private Cols(Items.Size), PointCols(Items.Size), StrokeWidths(Items.Size) As Int
	Private Names(Items.Size), PointTypes(Items.Size) As String
	Private Filled(Items.Size) As Boolean
	
	PD = Points.Get(0)
	x0 = Graph.Left
	Private py0(PD.YArray.Length), py1(PD.YArray.Length) As Double
	Private psy0(PD.YArray.Length), psy1(PD.YArray.Length) As Double
	py0 = PD.YArray
	For i = 0 To py0.Length - 1
		Private ID As ItemData
		ID = Items.Get(i)
		Cols(i) = ID.Color
		PointCols(i) = ID.PointColor
		Names(i) = ID.Name
		StrokeWidths(i) = ID.StrokeWidth
		PointTypes(i) = ID.PointType
		Filled(i) = ID.Filled
		psy0(i) = Graph.Bottom - (py0(i) - Scale.MinVal) * Scale.Y
	Next
	For i = 1 To Points.Size - 1
		Private PD As PointData
		PD = Points.Get(i)
		py1 = PD.YArray
		x1 = Graph.Left + i * Scale.X
		For j = 0 To py1.Length - 1
			psy1(j) = Graph.Bottom - (py1(j) - Scale.MinVal) * Scale.Y
			xcvsGraph.DrawLine(x0, psy0(j), x1, psy1(j), Cols(j), StrokeWidths(j))
			psy0(j) = psy1(j)
		Next
		x0 = x1
	Next

	For i = 1 To Points.Size - 1
		Private PD As PointData
		PD = Points.Get(i)
		py1 = PD.YArray
		x1 = Graph.Left + i * Scale.X
		For j = 0 To py1.Length - 1
			psy1(j) = Graph.Bottom - (py1(j) - Scale.MinVal) * Scale.Y
			If PointTypes(j) <> "NONE" Then
				DrawPoint(x1, psy1(j), PointCols(j), PointTypes(j), Filled(j), StrokeWidths(j))
			End If
		Next
	Next
	
	xcvsGraph.DrawRect(Graph.Rect, Graph.GridFrameColor, False, 2dip)
	If Scale.MinVal< 0 And Scale.MaxVal > 0 Then
		Private mYAxis0 = Graph.Bottom + Scale.MinVal * Scale.Y As Int
		xcvsGraph.DrawLine(Graph.Left, mYAxis0, Graph.Right, mYAxis0, Graph.GridFrameColor, 2dip)
	End If

	If Legend.IncludeLegend <> "NONE" And Points.Size > 0 Then
		DrawLegend
	End If
	
	xcvsGraph.Invalidate
End Sub

'draws a point at each StrokeTick
Private Sub DrawPoint(X As Int, Y As Int, Color As Int, PointType As String, Filled As Boolean, StrokeWidth As Int)
	Private dx As Int 
	
	dx = Max(4dip, 1.4 * StrokeWidth)
	Select PointType
		Case "CIRCLE"
			If Filled = False Then
				xcvsGraph.DrawCircle(X, Y, dx, Graph.ChartColor, True, 2dip)
			End If
			xcvsGraph.DrawCircle(X, Y, dx, Color, Filled, 2dip)
		Case "SQUARE"
			Private r As B4XRect
			r.Initialize(X - dx, Y - dx, X + dx, Y + dx)
			If Filled = False Then
				xcvsGraph.DrawRect(r, Graph.ChartColor, True, 2dip)				
			End If
			xcvsGraph.DrawRect(r, Color, Filled, 2dip)
		Case "TRIANGLE"
			Private triPath As B4XPath
			triPath.Initialize(X - dx, Y + 0.8 * dx)
			triPath.LineTo(X, Y - 1.2 * dx)
			triPath.LineTo(X + dx, Y + 0.8 * dx)
			triPath.LineTo(X - dx, Y + 0.8 * dx)
			xcvsGraph.ClipPath(triPath)
			Private r As B4XRect
			r.Initialize(X - dx, Y - dx, X + dx, Y + dx)	
					
			If Filled = False Then
				xcvsGraph.DrawRect(r, Graph.ChartColor, True, 1dip)
				xcvsGraph.RemoveClip
				xcvsGraph.DrawLine(X - dx, Y + dx, X, Y - dx, Color, 2dip)
				xcvsGraph.DrawLine(X, Y - dx, X + dx, Y + dx, Color, 2dip)
				xcvsGraph.DrawLine(X - dx, Y + dx, X + dx, Y + dx, Color, 2dip)
			Else
				xcvsGraph.DrawRect(r, Color, True, 1dip)
				xcvsGraph.RemoveClip
			End If
		Case "RHOMBUS"
			Private triPath As B4XPath
			triPath.Initialize(X - dx, Y)
			triPath.LineTo(X, Y -  dx)
			triPath.LineTo(X + dx, Y)
			triPath.LineTo(X, Y + dx)
			triPath.LineTo(X - dx, Y)
			xcvsGraph.ClipPath(triPath)
			Private r As B4XRect
			r.Initialize(X - dx, Y - dx, X + dx, Y + dx)
					
			If Filled = False Then
				xcvsGraph.DrawRect(r, Graph.ChartColor, True, 1dip)
				xcvsGraph.RemoveClip
				xcvsGraph.DrawLine(X - dx, Y, X, Y - dx, Color, 2dip)
				xcvsGraph.DrawLine(X, Y - dx, X + dx, Y, Color, 2dip)
				xcvsGraph.DrawLine(X + dx, Y, X, Y + dx, Color, 2dip)
				xcvsGraph.DrawLine(X, Y + dx, X - dx, Y, Color, 2dip)
			Else
				xcvsGraph.DrawRect(r, Color, True, 1dip)
				xcvsGraph.RemoveClip
			End If
		Case "CROSS+"
			dx = dx + 1dip
			xcvsGraph.DrawLine(X, Y - dx, X, Y + dx, Color, 2dip)
			xcvsGraph.DrawLine(X - dx, Y, X + dx, Y, Color, 2dip)
		Case "CROSSX", "CROSSx"
			xcvsGraph.DrawLine(X - dx, Y + dx, X + dx, Y - dx, Color, 2dip)
			xcvsGraph.DrawLine(X - dx, Y - dx, X + dx, Y + dx, Color, 2dip)
	End Select
End Sub

'draws the bars in a BAR chart
Private Sub DrawBars
	Private i, j, x0, x, h, y As Int
	Private Cols(Items.Size), ACols(Items.Size) As Int
	Private Names(Items.Size) As String

	For i = 0 To Items.Size - 1
		Private ID As ItemData
		ID = Items.Get(i)
		Cols(i) = ID.Color
		Private ARGB As ARGBColor
		Private BmpCreate As BitmapCreator
		BmpCreate.Initialize(10, 10)
		BmpCreate.ColorToARGB(Cols(i), ARGB)
		ACols(i) = xui.Color_ARGB(Graph.GradientColorsAlpha, ARGB.r, ARGB.g, ARGB.b)
		Names(i) = ID.Name
	Next
	
	If Graph.ChartType = "BAR" Then
		Private mYAxis0 = Graph.Bottom + Scale.MinVal * Scale.Y As Int
	
		For i = 0 To Points.Size - 1
			Private PD As PointData
			PD = Points.Get(i)
			Private py(PD.YArray.Length) As Double
			x0 = Graph.Left + Graph.XOffset + (i  + 0.5) * Graph.XInterval - Graph.BarWidth / 2
			py = PD.YArray

			For j = 0 To PD.YArray.Length - 1
				Private r, rb As B4XRect
				x = x0 + j * Graph.BarSubWidth
				h = py(j) * Scale.Y
				
				If h > 0 Then
					r.Initialize(x, mYAxis0 - h, x + Graph.BarSubWidth, mYAxis0)
				Else
					r.Initialize(x, mYAxis0, x + Graph.BarSubWidth, mYAxis0 - h)
				End If
				If Graph.GradientColors = False Then
					xcvsGraph.DrawRect(r, Cols(j), True, 1dip)
				Else
					Private bmc1 As BitmapCreator
					rb.Initialize(0, 0, Graph.BarSubWidth, Max(1, Abs(h)))
					bmc1.Initialize(Graph.BarSubWidth, Max(1, Abs(h)))
					If h > 0 Then
						bmc1.FillGradient(Array As Int(Cols(j), ACols(j)), rb, "TOP_BOTTOM")
					Else
						bmc1.FillGradient(Array As Int(Cols(j), ACols(j)), rb, "BOTTOM_TOP")
					End If
					xcvsGraph.DrawBitmap(bmc1.Bitmap, r)
				End If
			Next
		Next
		xcvsGraph.DrawLine(Graph.Left, mYAxis0, Graph.Right, mYAxis0, Graph.GridFrameColor, 1dip)

		If Graph.IncludeValues = True And PD.YArray.Length = 1 Then
			DrawBarValues
		End If
	Else 'Graph.ChartType = "STACKED_BAR"
		Private mYAxis0 = Graph.Bottom As Int
	
		For i = 0 To Points.Size - 1
			Private PD As PointData
			PD = Points.Get(i)
			Private py(PD.YArray.Length) As Double
			x0 = Graph.Left + Graph.XOffset + (i  + 0.5) * Graph.XInterval - Graph.BarWidth / 2
			py = PD.YArray
		
			y = mYAxis0
			For j = 0 To PD.YArray.Length - 1
				Private r, rb As B4XRect
				h = py(j) * Scale.Y
				r.Initialize(x0, y - h, x0 + Graph.BarWidth, y)
				If Graph.GradientColors = False Then
					xcvsGraph.DrawRect(r, Cols(j), True, 1dip)
				Else
					rb.Initialize(0, 0, Graph.BarSubWidth, Max(1, Abs(h)))
					Private bmc1 As BitmapCreator
					bmc1.Initialize(Graph.BarSubWidth, Max(1, Abs(h)))
					bmc1.FillGradient(Array As Int(Cols(j), ACols(j)), rb, "TOP_BOTTOM")
					xcvsGraph.DrawBitmap(bmc1.Bitmap, r)
				End If
				y = y - h
			Next
		Next
		xcvsGraph.DrawLine(Graph.Left, mYAxis0, Graph.Right, mYAxis0, Graph.GridFrameColor, 1dip)
	End If
	
	If Legend.IncludeLegend <> "NONE" And Items.Size > 1 Then
		DrawLegend
	End If
	
	xcvsGraph.Invalidate
End Sub

'draws the bar values, only for single bar charts
Private Sub DrawBarValues
	Private i, h, x, y As Int
	Private Col As Int
	Private txt As String
	Private mYAxis0 = Graph.Bottom + Scale.MinVal * Scale.Y As Int

	Private ID As ItemData
	ID = Items.Get(0)
	
	For i = 0 To Points.Size - 1
		Private PD As PointData
		PD = Points.Get(i)
		Private py(PD.YArray.Length) As Double
		py = PD.YArray
		x = Graph.Left + Graph.XOffset + (i + 0.5) * Graph.XInterval
		h = py(0) * Scale.Y
		If Abs(h) > 1.5 * Texts.ScaleTextHeight Then
			y = mYAxis0 - h / 2
			If h > 0 Then
				y = y + 0.3 * Texts.ScaleTextHeight
			Else
				y = y + 0.25 * Texts.ScaleTextHeight
			End If			
			Col = GetContrastColor(ID.Color)
		Else
			y = mYAxis0 - h
			If h > 0 Then
				y = y - Texts.ScaleTextHeight / 3
			Else
				y = y + 0.9 * Texts.ScaleTextHeight
			End If
			
			Col = GetContrastColor(Graph.ChartColor)
		End If
		txt = py(0)
		xcvsGraph.DrawText(txt, x, y, Texts.ScaleFont, Col, "CENTER")
	Next
End Sub

'draws the pies chart
Private Sub DrawPies
	xcvsGraph.DrawRect(xcvsGraph.TargetRect, Graph.ChartColor, True, 1dip)
	
	Dim Total As Float
	For Each Item As ItemData In Items
		Total = Total + Item.Value
	Next
	
	Private CenterX, CenterY, TitleHeight As Int
	
	If Graph.Title <> "" Then
		TitleHeight = Texts.TitleTextHeight
	End If
	Private Radius As Float = Min(xcvsGraph.TargetRect.Width, (xcvsGraph.TargetRect.Height - TitleHeight)) / 2 - 10dip
	
	If Legend.IncludeLegend <> "NONE" Then
		If xcvsGraph.TargetRect.Width > xcvsGraph.TargetRect.Height Then
			CenterX = Radius + 10dip
		Else
			CenterX = xcvsGraph.TargetRect.Width / 2
		End If
	Else
		CenterX = xcvsGraph.TargetRect.Width / 2
	End If
	CenterY = xcvsGraph.TargetRect.Height - Radius - 10dip
	
	If Graph.Title <> "" Then
		xcvsGraph.DrawText(Graph.Title, xcvsGraph.TargetRect.Width / 2, 1.15 * Texts.TitleTextHeight, Texts.TitleFont, xui.Color_Black, "CENTER")
	End If
	
	Private RadiusText As Float = Radius * 0.7
	Private StartAngle, TotalAngle, MidAngle As Float
	TotalAngle = 360 - Graph.PieGapDegrees * Items.Size
	Private rectCircle As B4XRect
	rectCircle.Initialize(CenterX - Radius, CenterY - Radius, CenterX + Radius, CenterY + Radius)
	Private Percentage As Int
	Private Percentage As Int
	For Each Item As ItemData In Items
		Private mPath As B4XPath
		Private Angle As Float = Item.Value / Total * TotalAngle
		If Angle = TotalAngle Then
			If Graph.GradientColors = False Then
				xcvsGraph.DrawCircle(CenterX, CenterY, Radius, Item.Color, True, 0)
			Else				
			End If
		Else
			Private ARGB As ARGBColor
			Private BmpCreate As BitmapCreator
			Private Acol As Int
			BmpCreate.Initialize(10, 10)
			BmpCreate.ColorToARGB(Item.Color, ARGB)
			Acol = xui.Color_ARGB(Graph.GradientColorsAlpha, ARGB.r, ARGB.g, ARGB.b)
			
			mPath.InitializeArc(CenterX, CenterY, Radius, StartAngle, Angle)
			StartAngle = StartAngle + Angle + Graph.PieGapDegrees
			xcvsGraph.ClipPath(mPath)
			If Graph.GradientColors = False Then
				xcvsGraph.DrawCircle(CenterX, CenterY, Radius, Item.Color, True, 0)
			Else	
				Private rb As B4XRect
				rb.Initialize(0, 0, 2 * Radius, 2 * Radius)
				Private bc1 As BitmapCreator
				bc1.Initialize(2 * Radius, 2 * Radius)
#If B4i
				xcvsGraph.DrawRect(xcvsGraph.TargetRect, Item.Color, True, 0) 'provisional
#Else
				'this code doesn't work yet with B4i yet, FillRadialGradient is missing in the BitmapCreator library
				bc1.FillRadialGradient(bc1, Array As Int(Acol, Item.Color), rb)
				xcvsGraph.DrawBitmap(bc1.Bitmap, rectCircle)
#End If
			End If
			xcvsGraph.RemoveClip
		End If
	Next
	
	If Graph.PieAddPerentage Then
		For Each Item As ItemData In Items
			Private mPath As B4XPath
			Private Angle As Float = Item.Value / Total * TotalAngle
			If Angle = TotalAngle Then
				xcvsGraph.DrawCircle(CenterX, CenterY, Radius, Item.Color, True, 0)
			Else
				StartAngle = StartAngle + Angle + Graph.PieGapDegrees
				Private x, y As Int
				Private txt As String
				MidAngle = StartAngle - Angle /2 - Graph.PieGapDegrees
				x = CenterX + RadiusText * CosD(MidAngle)
				y = CenterY + RadiusText * SinD(MidAngle) + 5dip
				Percentage = Item.Value / Total * 100
				txt = Percentage & " %"
				xcvsGraph.DrawText(txt, x, y, Texts.AxisFont, GetContrastColor(Item.Color), "CENTER")
			End If
		Next
	End If
	
	If Legend.IncludeLegend <> "NONE" And Items.Size > 0 Then
		DrawLegend
	End If
	
	xcvsGraph.Invalidate
End Sub

'gets the x intervals and x scale for LINE charts
Private Sub GetXIntervals
	Private I As Int
	
	Scale.X = Graph.Width / (Points.Size - 1)
	
	For i = 0 To Points.Size - 1
		Private PD As PointData
		PD = Points.Get(I)
		If PD.ShowTick = True Then
			Scale.NbXIntervals = Scale.NbXIntervals + 1
		End If
	Next
	Scale.X = Graph.Width / (Points.Size - 1)
End Sub

'clears all data, not the title nor axis names
Public Sub ClearData
	Items.Clear
	Points.Clear
End Sub

Private Sub MeasureTextWidth(Text As String, Font1 As B4XFont) As Int
#If B4A 
	Private bmp As Bitmap
	bmp.InitializeMutable(2dip, 2dip)
	Private cvs As Canvas
	cvs.Initialize2(bmp)
	Return cvs.MeasureStringWidth(Text, Font1.ToNativeFont, Font1.Size)
#Else If B4i
	Return Text.MeasureWidth(Font1.ToNativeFont)
#Else If B4J
	Dim jo As JavaObject
	jo.InitializeNewInstance("javafx.scene.text.Text", Array(Text))
	jo.RunMethod("setFont",Array(Font1.ToNativeFont))
	jo.RunMethod("setLineSpacing",Array(0.0))
	jo.RunMethod("setWrappingWidth",Array(0.0))
	Dim Bounds As JavaObject = jo.RunMethod("getLayoutBounds",Null)
	Return Bounds.RunMethod("getWidth",Null)
#End If
End Sub

Private Sub MeasureTextHeight(Text As String, Font1 As B4XFont) As Int
#If B4A 	
	Private bmp As Bitmap
	bmp.InitializeMutable(2dip, 2dip)
	Private cvs As Canvas
	cvs.Initialize2(bmp)
	Return cvs.MeasureStringHeight(Text, Font1.ToNativeFont, Font1.Size)
#Else If B4i
	Return Text.MeasureHeight(Font1.ToNativeFont)
#Else If B4J
	Dim jo As JavaObject
	jo.InitializeNewInstance("javafx.scene.text.Text", Array(Text))
	jo.RunMethod("setFont",Array(Font1.ToNativeFont))
	jo.RunMethod("setLineSpacing",Array(0.0))
	jo.RunMethod("setWrappingWidth",Array(0.0))
	Dim Bounds As JavaObject = jo.RunMethod("getLayoutBounds",Null)
	Return Bounds.RunMethod("getHeight",Null)
#End If
End Sub

'gets returns white for a dark color or returns black for a light color
Private Sub GetContrastColor(Color As Int) As Int
	Private a, r, g, b, yiq As Int	'ignore
	
	a = Bit.UnsignedShiftRight(Bit.And(Color, 0xff000000), 24)
	r = Bit.UnsignedShiftRight(Bit.And(Color, 0xff0000), 16)
	g = Bit.UnsignedShiftRight(Bit.And(Color, 0xff00), 8)
	b = Bit.And(Color, 0xff)
	
	yiq = r * 0.299 + g * 0.587 + b * 0.114
	
	If yiq > 128 Then
		Return xui.Color_Black
	Else
		Return xui.Color_White
	End If
End Sub

'draws the legend
Private Sub DrawLegend
	Private y As Int = 0.8 * Legend.TextHeight
	Private y1, w, x As Int
	Private h As Int = 1.2 * Legend.TextHeight
	Private box As Int = 0.7 * Legend.TextHeight
	Private textVerticalOffset As Int = 0.25 * Legend.TextHeight
	If xui.IsB4i Then textVerticalOffset = 0.3 * Legend.TextHeight
	Private i As Int
	Private r As B4XRect
	
	Select Legend.IncludeLegend
		Case "TOP_RIGHT"
			h = Texts.AxisTextHeight * 1.2
			For Each Item As ItemData In Items
				Private txt As String = Item.Name
				If Graph.ChartType = "PIE" And Graph.IncludeValues Then
					txt = txt & " : " & Item.Value
				End If
				w = Max(w, MeasureTextWidth(txt, Legend.TextFont))
			Next
			w = w + 2 * box + Texts.AxisTextHeight
			x = xcvsGraph.TargetRect.Width - w - 0.5 * box
			r.Initialize(x - box, y - 0.5 * box, x + w, y + h * Items.Size + 0.5 * box)
			xcvsGraph.DrawRect(r, 0xBBFFFFFF, True, 0)
			For Each Item As ItemData In Items
				Private top As Int = y + h * i
				r.Initialize(x, top + 0.5 * h - 0.65 * box, x + box, top + 0.5 * h + 0.35 * box)
				xcvsGraph.DrawRect(r, Item.Color, True, 0)
				Private txt As String = Item.Name
				If Graph.ChartType = "PIE" And Graph.IncludeValues Then
					txt = txt & " : " & Item.Value
				End If
				xcvsGraph.DrawText(txt, x + box + box, top + 0.5 * h + textVerticalOffset, Legend.TextFont, xui.Color_Black, "LEFT")
				i = i + 1
			Next

		Case "BOTTOM"
			Private x, y0, y As Int
			Private i As Int
			Private r As B4XRect
			
			y0  = xcvsGraph.TargetRect.Height - Legend.Height + 0.6 * Legend.TextHeight
			x = box

			r.Initialize(0.5 * box, xcvsGraph.TargetRect.Height - Legend.Height - 0.5 * box, xcvsGraph.TargetRect.Width - 0.5 * box, xcvsGraph.TargetRect.Height - 0.5 * box)
			xcvsGraph.DrawRect(r, 0x66FFFFFF, True, 0)
			
			For i = 0 To Items.Size - 1
				Private Item As ItemData
				Item = Items.Get(i)
				y = y0 + 1.6 * box * Legend.LineNumbers.Get(i)
				Private txt As String = Item.Name
				If Legend.LineChange.Get(i) = True Then
					x = box				
				End If

				r.Initialize(x, y - box, x + box, y)
				xcvsGraph.DrawRect(r, Item.Color, True, 0)
				Private txt As String = Item.Name
				
				#If B4A
					y1 = y + 0.1 * box
				#Else If B4i
					y1 = y + 0.3 * box
				#Else
					y1 = y - 0.1 * box
				#End If
				xcvsGraph.DrawText(txt, x + 1.5 * box, y1, Legend.TextFont, xui.Color_Black, "LEFT")
				x = x + 2.5 * box + MeasureTextWidth(txt, Legend.TextFont)
			Next
	End Select
End Sub

'gets the number of lines for the BOTTOM legend and the line changes
Private Sub GetLegendLineNumbers(Limit As Int)
	Private x As Int
	Private box As Int = 0.7 * Legend.TextHeight
	
	Legend.LineNumber = 1
	Legend.LineNumbers.Clear
	Legend.LineChange.Clear
	
	Private AllTooBig = False As Boolean
	
	For i = 0 To Items.Size - 1
		Private Item As ItemData
		Item = Items.Get(i)
		Private txt As String = Item.Name
		If 2.5 * box + MeasureTextWidth(txt, Legend.TextFont) > Limit Then
			AllTooBig = True
		End If
	Next
	
	If AllTooBig = True Then
		Legend.LineNumber = Items.Size
		For i = 0 To Items.Size - 1
			Legend.LineChange.Add(True)
			Legend.LineNumbers.Add(i)
		Next
	Else
		x = 0
		For i = 0 To Items.Size - 1
			Private Item As ItemData
			Item = Items.Get(i)
			Private txt As String = Item.Name
			x = x + 2.5 * box + MeasureTextWidth(txt, Legend.TextFont)
			If x > Limit Then
				x = 2.5 * box + MeasureTextWidth(txt, Legend.TextFont)
				Legend.LineNumber = Legend.LineNumber + 1
				Legend.LineChange.Add(True)
			Else
				Legend.LineChange.Add(False)
			End If
			Legend.LineNumbers.Add(Legend.LineNumber - 1)
		Next
	End If
End Sub

'formats a number with scientific notation
Public Sub NumberFormat3(Number As Double, MaxDigits As Int) As String
	Private mant, exp, lng, lng2 As Double
	Private str, strMinus As String
	
	If Number = 0 Then Return "0"
	
	If Number < 0 Then
		strMinus = "-"
	Else
		strMinus = ""
	End If
	lng = Logarithm(Abs(Number), 10)
	exp = Floor(lng)
	If exp < 0 Then
		lng2 = Floor(lng)
		lng = -lng2 + lng
	Else
		lng = lng - exp
	End If
	
	If exp < MaxDigits And exp > -2 Then
		str = NumberFormat2(Number, 1, MaxDigits - 1 - exp, 0, False)
	Else
		mant = Power(10, lng)
		str = strMinus & NumberFormat2(mant, 1, MaxDigits - 1, 0, False)
		str = str & "E" & exp
	End If
	Return str
End Sub

'gets or sets the Chart title
Public Sub getTitle As String
	Return Graph.Title
End Sub

Public Sub setTitle(Title As String)
	Graph.Title = Title
End Sub

'gets or sets the X axis name
Public Sub getXAxisName As String
	Return Graph.XAxisName
End Sub

Public Sub setXAxisName(XAxisName As String)
	Graph.XAxisName = XAxisName
End Sub

'gets or sets the Y axis name
Public Sub getYAxisName As String
	Return Graph.YAxisName
End Sub

Public Sub setYAxisName(YAxisName As String)
	Graph.YAxisName = YAxisName
End Sub

'gets or sets the Y scale max value
'setting YSclaeMaxValue works only with AutomaticScale = False
Public Sub getYScaleMaxValue As Double
	Return Scale.MaxVal
End Sub

Public Sub setYScaleMaxValue(YScaleMaxValue As Double)
	Scale.MaxManu = YScaleMaxValue
	Scale.MaxVal = YScaleMaxValue
End Sub

'gets or sets the Y scale min value
'setting YSclaeMinValue works only with AutomaticScale = False
Public Sub getYScaleMinValue As Double
	Return Scale.MinVal
End Sub

Public Sub setYScaleMinValue(YScaleMinValue As Double)
	Scale.MinManu = YScaleMinValue
	Scale.MinVal = YScaleMinValue
End Sub

'gets or sets the IncludeLegend property
'Possible values: NONE, TOP_RIGHT, BOTTOM
Public Sub getIncludeLegend As String
	Return Legend.IncludeLegend
End Sub

Public Sub setIncludeLegend(IncludeLegend As String)
	Legend.IncludeLegend = IncludeLegend
End Sub

'gets or sets the IncludeValues property
'Possible only for single bar charts or pie charts with TOP_RIGHT legend
Public Sub getIncludeValues As String
	Return Graph.IncludeValues
End Sub

Public Sub setIncludeValues(IncludeValues As String)
	Graph.IncludeValues = IncludeValues
End Sub

'gets or sets the AutomaticScale property
Public Sub getAutomaticScale As Boolean
	Return Scale.Automatic
End Sub

Public Sub setAutomaticScale(AutomaticScale As Boolean)
	Scale.Automatic = AutomaticScale
End Sub

'gets or sets the X scale text orientation
'Possible values: VERTICAL, HORIZONTAL, 45 DEGREES
Public Sub getXScaleTextOrientation As String
	Return Graph.XScaleTextOrientation
End Sub

Public Sub setXScaleTextOrientation(XScaleTextOrientation As String)
	Graph.XScaleTextOrientation = XScaleTextOrientation
End Sub

'gets or sets the chart type
'Possible values: BAR, STACKED_BAR, LINE, PIE
Public Sub getChartType As String
	Return Graph.ChartType
End Sub

Public Sub setChartType(ChartType As String)
	If ChartType = "BAR" Or ChartType = "STACKED_BAR" Or ChartType = "LINE" Or ChartType = "PIE" Then
		Graph.ChartType = ChartType
	Else
		Log("Wrong chart type")
	End If
End Sub

'gets or sets the Left property
Public Sub getLeft As Int
	Return xBase.Left
End Sub

Public Sub setLeft(Left As Int)
	xBase.Left = Left
End Sub

'gets or sets the Top property
Public Sub getTop As Int
	Return xBase.Left
End Sub

Public Sub setTop(Top As Int)
	xBase.Top = Top
End Sub

'gets or sets the Width property
Public Sub getWidth As Int
	Return xBase.Width
End Sub

Public Sub setWidth(Width As Int)
	xBase.Width = Width
	DrawChart
End Sub

'gets or sets the Height property
Public Sub getHeight As Int
	Return xBase.Height
End Sub

Public Sub setHeight(Height As Int)
	xBase.Height = Height
	DrawChart
End Sub

'gets or sets the Visible property
Public Sub getVisible As Boolean
	Return xBase.Visible
End Sub

Public Sub setVisible(Visible As Boolean)
	xBase.Visible = Visible
End Sub

'gets or sets the AutomaticTextSizes property
Public Sub getAutomaticTextSizes As Boolean
	Return Texts.AutomaticTextSizes
End Sub

Public Sub setAutomaticTextSizes(AutomaticTextSizes As Boolean)
	Texts.AutomaticTextSizes = AutomaticTextSizes
End Sub

'gets or sets the TitleTextSize property
'setting this text size sets automatically AutomaticTextSizes = False
Public Sub getTitleTextSize As Float
	Return Texts.TitleTextSize
End Sub

Public Sub setTitleTextSize(TitleTextSize As Float)
	Texts.TitleTextSize = TitleTextSize
	Texts.TitleFont = xui.CreateDefaultFont(Texts.TitleTextSize)
	Texts.AutomaticTextSizes = False
End Sub

'gets or sets the AxisTextSize property
'setting this text size sets automatically AutomaticTextSizes = False
Public Sub getAxisTextSize As Float
	Return Texts.AxisTextSize
End Sub

Public Sub setAxisTextSize(AxisTextSize As Float)
	Texts.AxisTextSize = AxisTextSize
	Texts.AxisFont = xui.CreateDefaultFont(Texts.AxisTextSize)
	Texts.AutomaticTextSizes = False
End Sub

'gets or sets the ScaleTextSize property
'setting this text size sets automatically AutomaticTextSizes = False
Public Sub getScaleTextSize As Float
	Return Texts.ScaleTextSize
End Sub

Public Sub setScaleTextSize(ScaleTextSize As Float)
	Texts.ScaleTextSize = ScaleTextSize
	Texts.ScaleFont = xui.CreateDefaultFont(Texts.ScaleTextSize)
	Texts.AutomaticTextSizes = False
End Sub

'gets or sets the LegendTextSize property
'setting this text size sets automatically AutomaticTextSizes = False
Public Sub getLegendTextSize As Float
	Return Legend.TextSize
End Sub

Public Sub setLegendTextSize(LegendTextSize As Float)
	Legend.TextSize = LegendTextSize
	Legend.TextFont = xui.CreateDefaultFont(Legend.TextSize)
	Texts.AutomaticTextSizes = False
End Sub

'gets or sets the ValuesTextSize property
'setting this text size sets automatically AutomaticTextSizes = False
Public Sub getValuesTextSize As Float
	Return Values.TextSize
End Sub

Public Sub setValuesTextSize(LegendTextSize As Float)
	Values.TextSize = LegendTextSize
	Values.TextFont = xui.CreateDefaultFont(Values.TextSize)
	Texts.AutomaticTextSizes = False
End Sub

'gets or sets the DisplayValues property
'if True, displays the point values when moving the finger or the cursor on the chart.
Public Sub getDisplayValues As Boolean
	Return Values.Show
End Sub

Public Sub setDisplayValues(DisplayValues As Boolean)
	Values.Show = DisplayValues
End Sub

'gets or sets the GradientColors property
Public Sub getGradientColors As Boolean
	Return Graph.GradientColors
End Sub

Public Sub setGradientColors(GradientColors As Boolean)
	Graph.GradientColors = GradientColors
End Sub

'gets or sets the GradientColorsAlpha property
'values between 0 and 255
'setting this value, set automatically the GradientColors property to True
Public Sub getGradientColorsAlpha As Int
	Return Graph.GradientColorsAlpha
End Sub

Public Sub setGradientColorsAlpha(GradientColorsAlpha As Int)
	Graph.GradientColorsAlpha = GradientColorsAlpha
	Graph.GradientColorsAlpha = Max(0, Graph.GradientColorsAlpha)
	Graph.GradientColorsAlpha = Min(255, Graph.GradientColorsAlpha)
End Sub

'sets the ChartBackgroundColor property
'the color must be an xui.Color
'Example code: <code>xChart1.ChartBackgroundColor = xui.Color_Red</code>
Public Sub setChartBackgroundColor(Color As Int)
	Graph.ChartColor = Color
End Sub
	
'sets the GridFrameColor property
'the color must be an xui.Color
'Example code: <code>xChart1.GridFrameColor = xui.Color_Red</code>
Public Sub setGridFrameColor(Color As Int)
	Graph.GridFrameColor = Color
End Sub
	
'sets the GridColor property
'the color must be an xui.Color
'Example code: <code>xChart1.GridColor = xui.Color_Red</code>
Public Sub setGridColor(Color As Int)
	Graph.GridColor = Color
End Sub

'sets the TitleTextColor property
'the color must be an xui.Color
'Example code: <code>xChart1.TitleTextColor = xui.Color_Red</code>
Public Sub setTitleTextColor(Color As Int)
	Texts.TitleTextColor = Color
End Sub

'sets the ScaleTextColor property
'the color must be an xui.Color
'Example code: <code>xChart1.ScaleTextColor = xui.Color_Red</code>
Public Sub setScaleTextColor(Color As Int)
	Texts.ScaleTextColor = Color
End Sub

'sets the ValuesTextColor property	
'the color must be an xui.Color
'Example code: <code>xChart1.ValuesTextColor = xui.Color_Red</code>
Public Sub setValuesTextColor(Color As Int)
	Values.TextColor = Color
End Sub

'gets or sets the NbYIntervals property, number of Y axis intervals
'should be an even number, otherwise the 0 scale value might not be displayed
Public Sub getNbYIntervals As Int
	Return Scale.NbYIntervals
End Sub

Public Sub setNbYIntervals (NbYIntervals As Int)
	Scale.NbYIntervals = NbYIntervals
End Sub

'gets or sets the YZeroAxis property for LINE charts
'if all values are positives, sets the lower Y scale to zero
'if all values are negatives, sets the upper Y scale to zero
Public Sub getYZeroAxis As Boolean
	Return Scale.YZeroAxis
End Sub

Public Sub setYZeroAxis (YZeroAxis As Boolean)
	Scale.YZeroAxis = YZeroAxis
End Sub
